#!/bin/bash
#
#

#<gorp>getting of right parameters

installdir=`pwd`;
prefixdir=$1;
url=$2;
prefixdircgi=$3;
urlcgi=$4;

if [ -z $prefixdir ]; then
	echo "Enter directory to install doctaur to:";read prefixdir;
fi

if [ -z $prefixdir ]; then
        echo "I do not know where to install Docatur.";exit;
fi

mkdir $prefixdir>>$installdir/install.log 2>>$installdir/install.log

if cd $prefixdir 2>>$installdir/install.log;then
     prefixdir=`pwd`; echo "$prefixdir - OK.";
 else echo "Can not create $prefixdir."; exit;
fi

dtdocs_copy='yes';
if [ -e dtdocs ];then
	echo 'Some documentations already exist in this destination. Would you like to copy manuals from the installation package anyway? (yes, no) [no]';
	read dtdocs_copy;
fi

if [ -z $url ]; then
        echo "Enter URL where Doctaur will reside [http://localhost/doctaur]: ";read url;
fi

if [ -z $url ]; then 
	url='http://localhost/doctaur';
fi

if [ -z $prefixdircgi ]; then
        echo "Where is cgi-bin directory to install doctaur cgi files to [$prefixdir/cgi-bin]:";read prefixdircgi;
fi
 
if [ -z $prefixdircgi ]; then
	prefixdircgi="$prefixdir/cgi-bin";
fi
 
mkdir $prefixdircgi>>$installdir/install.log 2>>$installdir/install.log
 
if cd $prefixdircgi 2>>$installdir/install.log;then
     prefixdircgi=`pwd`; echo "$prefixdircgi - OK.";
 else echo "Can not create $prefixdircgi."; exit;
fi
 
if cd $installdir 2>>$installdir/install.log;then
     echo "";
 else echo "undefined error"; exit;
fi
 
if [ -z $urlcgi ]; then
        echo "Enter URL of cgi-bin directory where Doctaur cgi files will reside [$url/cgi-bin]: ";read urlcgi;
fi
 
if [ -z $urlcgi ]; then
        urlcgi="$url/cgi-bin";
fi

#</gorp>

#<ac>apache configuration
right_apache_configuration='no';

echo "Apache configuration:
directories:
        $prefixdir
        $prefixdircgi
should be accessible by URLs:
        $url
        $urlcgi
and it should be possible to execute cgi files in directory:
        $prefixdircgi

Is your apache properly configured? (yes, no) [no]";
read right_apache_configuration;
case $right_apache_configuration in
	NO | no | No | n | N | '') 
		if which perl>>$installdir/install.log 2>>$installdir/install.log; then
		        eval `which perl` chngcnf_ac.pl $prefixdircgi $urlcgi;
	        else echo "You have to install Perl first, sorry.";exit;
		fi
		echo "Is it correct now? (yes, no) [no]";
		read right_apache_configuration;;
esac
case $right_apache_configuration in
        NO | no | No | n | N | '') echo "Correct apache configuratio before installation.";exit;;
esac
#</ac>

if [ -e $prefixdir/htdig ];
        then 
	rm -rf $prefixdir/htdig;
fi
echo "Be patient, please. It will take several minutes." 
cd $installdir/doctaur_inst>>$installdir/install.log 2>>$installdir/install.log
make clean>>$installdir/install.log>>$installdir/install.log 2>>$installdir/install.log
./configure --prefix=$prefixdir/htdig --with-cgi-bin-dir=$prefixdircgi --with-image-dir=$prefixdir/htdig/img --with-search-dir=$prefixdir/htdig/search>>$installdir/install.log 2>>$installdir/install.log

if which perl>>$installdir/install.log 2>>$installdir/install.log; then
        cd $installdir;eval `which perl` chngcnf0.pl $installdir $url;
        else echo "You have to install Perl first, sorry.";exit;
fi

cd $installdir/doctaur_inst>>$installdir/install.log 2>>$installdir/install.log
make>>$installdir/install.log 2>>$installdir/install.log
make install>>$installdir/install.log 2>>$installdir/install.log

#<codf>copying of doctaur files
cp -fr cgi-bin/* $prefixdircgi>>$installdir/install.log 2>>$installdir/install.log
chmod 0755 $prefixdircgi/*.pl>>$installdir/install.log 2>>$installdir/install.log 

mkdir $prefixdir/imgs>>$installdir/install.log 2>>$installdir/install.log
cp -rf imgs/* $prefixdir/imgs/>>$installdir/install.log 2>>$installdir/install.log
cp -fp conf/htdig.conf $prefixdir/htdig/conf/>>$installdir/install.log 2>>$installdir/install.log
mkdir $prefixdir/conf>>$installdir/install.log 2>>$installdir/install.log
cp -f conf/doctaur.conf $prefixdir/conf/>>$installdir/install.log 2>>$installdir/install.log
chmod 0666 $prefixdir/conf/doctaur.conf>>$installdir/install.log 2>>$installdir/install.log
chmod 0777 $prefixdir/conf>>$installdir/install.log 2>>$installdir/install.log     
ln -s $prefixdir/conf/doctaur.conf $prefixdircgi/doctaur.conf>>$installdir/install.log 2>>$installdir/install.log
cp -f doctaur_docs.js $prefixdir>>$installdir/install.log 2>>$installdir/install.log
cp -f doctaur_docs_com.js $prefixdir>>$installdir/install.log 2>>$installdir/install.log
cp -f doctaur.js $prefixdir>>$installdir/install.log 2>>$installdir/install.log
cp -f doctaur_com.js $prefixdir>>$installdir/install.log 2>>$installdir/install.log
cp -f doctaur_both.css $prefixdir>>$installdir/install.log 2>>$installdir/install.log
cp -f doctaur_ux.css $prefixdir>>$installdir/install.log 2>>$installdir/install.log
cp -f doctaur_w.css $prefixdir>>$installdir/install.log 2>>$installdir/install.log
cp -f GPL $prefixdir>>$installdir/install.log 2>>$installdir/install.log
if [ -e $prefixdir/messages.txt ];
	then true;else
	cp -p messages.txt  $prefixdir>>$installdir/install.log 2>>$installdir/install.log
	chmod 0666 $prefixdir/messages.txt>>$installdir/install.log 2>>$installdir/install.log
fi
cp -f GPL $prefixdir>>$installdir/install.log 2>>$installdir/install.log
if [ -e $prefixdir/requests.txt ];
        then true;else
        cp -p requests.txt  $prefixdir>>$installdir/install.log 2>>$installdir/install.log
        chmod 0666 $prefixdir/requests.txt>>$installdir/install.log 2>>$installdir/install.log
fi
cp -f index.html $prefixdir/index.html>>$installdir/install.log 2>>$installdir/install.log
cd ..>>$installdir/install.log  2>>$installdir/install.log  

case $dtdocs_copy in
        YES | yes | Yes | y | Y ) 
	cp -pr dtdocs $prefixdir/>>$installdir/install.log  2>>$installdir/install.log;
        chmod -R a+rwX $prefixdir/dtdocs>>$installdir/install.log 2>>$installdir/install.log;;
esac

cp -f $installdir/.dt_version $prefixdir/.dt_version>>$installdir/install.log 2>>$installdir/install.log
#</codf>


#<cohcfaei>changing of htdig conf file and echo instructions
if which perl>>$installdir/install.log 2>>$installdir/install.log; then
        cd $installdir;exec `which perl` chngcnf.pl $prefixdir $url $prefixdircgi $urlcgi `which perl`;
        else echo "You have to install Perl first, sorry.";
fi
#</cohcfaei>
